﻿#include "csetsubstation.h"
#include "ui_csetsubstation.h"
#include "modbus/cmanagemodbus.h"
#include "modbus/cmodbusslave.h"


CSetSubstation::CSetSubstation(QWidget *parent) :
    QWidget(parent),
    ui(new Ui::CSetSubstation)
{
    ui->setupUi(this);
    setWindowFlags(windowFlags() | Qt::Dialog);
    setWindowModality(Qt::WindowModal);

    m_pModbusSlave = nullptr;
    m_pModbusThread = nullptr;
}

CSetSubstation::~CSetSubstation()
{
    delete ui;
}

void CSetSubstation::on_btnStart_clicked()
{
    initThd();
    m_pModbusThread->start();
}

void CSetSubstation::initThd()
{
    if(m_pModbusSlave != nullptr)
    {
        m_pModbusSlave->stopThread();
        QThread::msleep(100);
        delete m_pModbusSlave;
        m_pModbusSlave = nullptr;
    }

    if(m_pModbusThread != nullptr)
    {
        delete m_pModbusThread;
        m_pModbusThread = nullptr;
    }


    QString ip = ui->txtIp->text();
    int nPort = ui->txtPort->text().toInt();
    m_pModbusSlave = new CManageModbus(ip.toStdString(), nPort);
    m_pModbusThread = new QThread;

    m_pModbusSlave->moveToThread(m_pModbusThread);

    bool b = connect(m_pModbusThread, &QThread::started, m_pModbusSlave, &CManageModbus::doWork);
    connect(m_pModbusThread, &QThread::finished, m_pModbusSlave, &CManageModbus::deleteLater);
}

