﻿#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include <QMainWindow>
#include <QTableWidget>

QT_BEGIN_NAMESPACE
namespace Ui { class MainWindow; }
QT_END_NAMESPACE

class CSetSubstation;
class CManageModbus;
struct S_ModbusConfigInfo;

class MainWindow : public QMainWindow
{
    Q_OBJECT

public:
    MainWindow(QWidget *parent = nullptr);
    ~MainWindow();

signals:
    void sigGetTableData(int nDataType, uint8_t *pData, int nDataLen);
private slots:
    void on_btnTest_clicked();

    void on_btnStart_clicked();

    void on_btnConnectServer_clicked();

    void on_btnStop_clicked();

    void on_btnDisConnectServer_clicked();
    void slotAddLog(bool bServer, bool bRecv, QString msg);
    void on_tableWidgetYx_cellDoubleClicked(int row, int column);

    void on_btnClear_clicked();

    void on_tableWidgetYc_cellChanged(int row, int column);

private:
    Ui::MainWindow *ui;
    CSetSubstation *m_pSetSub;
    QThread *m_pModbusThread;
    CManageModbus *m_pModbusSlave;

private:
    void initUi();
    void initThd();
    void addLog(bool bServer, bool bRecv, QString msg);
    void getModbusConfigInfo(S_ModbusConfigInfo& configInfo);//界面配置写入结构体
    void initTable(QTableWidget *pTable);
    void insertTable(int type);
    void insertTableRow(int type, QTableWidget *pTable, const QStringList &listInfo);
    void getTableData(QTableWidget *pTable, uint8_t *pData, int &nDataLen);
    void getTableData(QTableWidget *pTable, uint16_t *pData, int &nDataLen);
};
#endif // MAINWINDOW_H
