﻿#ifndef CMODBUSSLAVE_H
#define CMODBUSSLAVE_H

#include <QObject>
#include <QThread>


/*如果是windows平台则要加载相应的静态库和头文件*/
#ifdef _WIN32
#define _WINSOCK_DEPRECATED_NO_WARNINGS
#include <winsock2.h>
#include <windows.h>
#include "libmodbus/modbus.h"
#pragma comment(lib, "Ws2_32.lib")
//#pragma comment/*(lib, "modbus.lib")*/
/*linux平台*/
#else
#include <modbus/modbus.h>
#include <unistd.h>
#include <error.h>
#include <arpa/inet.h>
#include <sys/socket.h>
#include <sys/time.h>
#include <sys/select.h>
#endif

using namespace std;

class CModbusSlave : public QObject
{
    Q_OBJECT
public:
    explicit CModbusSlave(string host="0.0.0.0", uint16_t port=502, QObject *parent = nullptr);

    void stopThread();
public slots:
    void doWork();

signals:

private:
    std::mutex slavemutex;
    int m_errCount{ 0 };
    int m_modbusSocket{ -1 };
    bool m_initialized{ false };
    modbus_t* ctx{ nullptr };
    modbus_mapping_t* mapping{ nullptr };
    /*Mapping*/
    int m_numBits{ 60000 };
    int m_numInputBits{ 60000 };
    int m_numRegisters{ 60000 };
    int m_numInputRegisters{ 60000 };
    bool m_bStopThread;

private:
    void recieveMessages();
};

#endif // CMODBUSSLAVE_H
